Bug 13786 - strcasecmp_l, strncasecmp_l act as strcmp for multiarch x86 (localedata/tst-xlocale1 fails)
Summary: strcasecmp_l, strncasecmp_l act as strcmp for multiarch x86 (localedata/tst-x...
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: libc (show other bugs)
Version: 2.15
: P2 normal
Target Milestone: ---
Assignee: Carlos O'Donell
URL:
Keywords: glibc_2.15
Depends on:
Blocks:
 
Reported: 2012-02-29 21:44 IST by Joseph Myers
Modified: 2014-06-26 14:04 IST (History)
3 users (show)

See Also:
Host: i686-pc-linux-gnu
Target: i686-pc-linux-gnu
Build: i686-pc-linux-gnu
Last reconfirmed:
fweimer: security-


Attachments
Patch backported to 2.15 branch (949 bytes, patch)
2012-06-25 21:33 IST, Joseph Myers
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Joseph Myers 2012-02-29 21:44:52 IST
With multiarch enabled x86 builds of glibc, used on systems without SSSE3, the test localedata/tst-xlocale1 fails because strcasecmp_l and strncasecmp_l are wrongly implemented through an assembly implementation of strcmp that is not prepared to implement those functions.  I'll send a patch to libc-alpha.  This issue applies to both master and 2.15 branch.
Comment 1 Joseph Myers 2012-02-29 22:40:31 IST
Fixed on master.  Carlos, I think

commit 0bab47b6b255e77bd69206ab0dcfa97331fefa50
Author: Joseph Myers <joseph@codesourcery.com>
Date:   Wed Feb 29 22:37:38 2012 +0000

    Fix x86 strcasecmp_l (bug 13786).

should be backported to 2.15 branch.
Comment 2 Joseph Myers 2012-06-25 21:33:52 IST
Created attachment 6480 [details]
Patch backported to 2.15 branch

Carlos, please review this backport of the patch to 2.15 branch.  Tested x86.
Comment 3 Carlos O'Donell 2012-06-25 21:40:14 IST
Joseph,

This looks good for 2.15, please apply.
Comment 4 Joseph Myers 2012-06-25 21:44:59 IST
Fixed for 2.15.1 by:

commit 3e5bea052bfaa8d0a073f5e924ccc882ce3909bc
Author: Joseph Myers <joseph@codesourcery.com>
Date:   Wed Feb 29 22:37:38 2012 +0000

    Fix x86 strcasecmp_l (bug 13786).
    (cherry picked from commit 0bab47b6b255e77bd69206ab0dcfa97331fefa50)